#define	ADD	100
#define	SUB	101
#define	ADC	102
#define	SBC	103
#define	UDIV	104
#define	SDIV	105
#define	UMADDL	106
#define	UMSUBL	107
#define	UMULH	108
#define	SMADDL	109
#define	SMSUBL	110
#define	SMULH	111
#define	AND	112
#define	OR	113
#define	XOR	114
#define	XORN	115
#define	ORN	116
#define	BFM	117
#define	MOV	118
#define	MOVK	119
#define	BIC	120
#define	CLS	121
#define	CLZ	122
#define	CSEL	123
#define	CCMN	124
#define	CCMP	125
#define	CSINC	126
#define	CSINV	127
#define	CSNEG	128
#define	EXTR	129
#define	SBFM	130
#define	UBFM	131
#define	MADD	132
#define	MSUB	133
#define	RBIT	134
#define	REV16	135
#define	REV32	136
#define	REV	137
#define	SLL	138
#define	SRL	139
#define	SRA	140
#define	ROR	141
#define	NOP	142
#define	EADD	150

#define	FLAG	200
#define	JAL	201
#define	JCC	202
#define	JMP	203
#define	JPR	204
#define	LD	205
#define	LDNP	206
#define	LDP	207
#define	LDPC	208
#define	LDUR	209
#define	ST	210
#define	STNP	211
#define	STP	212
#define	STUR	213
#define	CBNZ	214
#define	CBZ	215
#define	TBNZ	216
#define	TBZ	217
#define	UDF	218

#define	BYTE	400
#define	HWORD	401
#define	WORD	402
#define	DWORD	403

#define	SXTB    0
#define	SXTH    1
#define	SXTW    2
#define	SXTX    3
#define	UXTB    4
#define	UXTH    5
#define	UXTW    6
#define	UXTX    7

#define IMMD    500
#define PC_VAL  600
#define PCP_VAL  650
#define NXT_PC  700
#define SP_VAL  800
#define NONE    900

void reg_dump(void);
long long int get_reg(int reg);
void put_reg(int reg, long long int value);

#define MAXPAGENUM 16
int get_mem(int addr, int size);
void put_mem(int addr, int value, int size);
int get_word(int addr);
void put_word(int addr, int data);
void mem_dump(unsigned int start, unsigned int end, int unit);

void fetch(void);
void decode(void);
void execute(void);
void instruction();

void disasm(unsigned int addr1, unsigned int addr2);

