#include <stdio.h>
#include "define.h"

extern int N_flag;
extern int Z_flag;
extern int C_flag;
extern int V_flag;

int PC;
int PC1;
int PC2;
long long int RF[31];
long long int SP;

long long int get_reg(int reg)
{
  if((reg>=0)&&(reg<=30))
    return RF[reg];
  if(reg==31)
    return 0LL;
  if(reg==SP_VAL)
    return SP;
  return 0LL;
}

void put_reg(int reg, long long int value)
{
  if((reg>=0)&&(reg<=30)){
    RF[reg] = value;
  }
  if(reg==SP_VAL){
    SP = value;
  }
}

void reg_dump(void)
{
    printf("00:%016llx 01:%016llx 02:%016llx 03:%016llx\n", RF[0], RF[1], RF[2], RF[3]);
    printf("04:%016llx 05:%016llx 06:%016llx 07:%016llx\n", RF[4], RF[5], RF[6], RF[7]);
    printf("08:%016llx 09:%016llx 10:%016llx 11:%016llx\n", RF[8], RF[9], RF[10], RF[11]);
    printf("12:%016llx 13:%016llx 14:%016llx 15:%016llx\n", RF[12], RF[13], RF[14], RF[15]);
    printf("16:%016llx 17:%016llx 18:%016llx 19:%016llx\n", RF[16], RF[17], RF[18], RF[19]);
    printf("20:%016llx 21:%016llx 22:%016llx 23:%016llx\n", RF[20], RF[21], RF[22], RF[23]);
    printf("24:%016llx 25:%016llx 26:%016llx 27:%016llx\n", RF[24], RF[25], RF[26], RF[27]);
    printf("28:%016llx 29:%016llx 30:%016llx sp:%016llx\n", RF[28], RF[29], RF[30], SP);
    printf("NZCV:%d%d%d%d\n",  N_flag, Z_flag, C_flag, V_flag);

}
