#include <stdio.h>
#include "define.h"

extern int N_flag;
extern int Z_flag;
extern int C_flag;
extern int V_flag;

int PC;
int PC1;
int PC2;
int RF[16];

int get_reg(int reg)
{
  if((reg>=0)&&(reg<=14))
    return RF[reg];
  if(reg==15)
    return PC1;
  return 0;
}

void put_reg(int reg, int value)
{
  if((reg>=0)&&(reg<=14)){
    RF[reg] = value;
  }
  else if(reg==15){
    PC = (value & 0xfffffffe);
  }
}

void reg_dump(void)
{
    printf("00:%08x 01:%08x 02:%08x 03:%08x 04:%08x 05:%08x 06:%08x 07:%08x\n",
	   RF[0], RF[1], RF[2], RF[3], RF[4], RF[5], RF[6], RF[7]);
    printf("08:%08x 09:%08x 10:%08x 11:%08x 12:%08x 13:%08x 14:%08x 15:%08x\n",
	   RF[8], RF[9], RF[10], RF[11], RF[12], RF[13], RF[14], PC1);
    printf("NZCV:%d%d%d%d\n",
	   N_flag, Z_flag, C_flag, V_flag);

}
