#include <stdio.h>
#include "define.h"

int PC;
int RF[32];

int get_reg(int reg)
{
  if((reg>=1)&&(reg<=31))
	  return RF[reg];
  return 0;
}

void put_reg(int reg, int value)
{
  if((reg>=1)&&(reg<=31))
    RF[reg] = value;
}

void reg_dump(void)
{
    printf("pc:%08x 01:%08x 02:%08x 03:%08x 04:%08x 05:%08x 06:%08x 07:%08x\n",
	   PC, RF[1], RF[2], RF[3], RF[4], RF[5], RF[6], RF[7]);
    printf("08:%08x 09:%08x 10:%08x 11:%08x 12:%08x 13:%08x 14:%08x 15:%08x\n",
	   RF[8], RF[9], RF[10], RF[11], RF[12], RF[13], RF[14], RF[15]);
    printf("16:%08x 17:%08x 18:%08x 19:%08x 20:%08x 21:%08x 22:%08x 23:%08x\n",
	   RF[16], RF[17], RF[18], RF[19], RF[20], RF[21], RF[22], RF[23]);
    printf("24:%08x 25:%08x 26:%08x 27:%08x 28:%08x 29:%08x 30:%08x 31:%08x\n",
	   RF[24], RF[25], RF[26], RF[27], RF[28], RF[29], RF[30], RF[31]);
}
