#include "define.h"


static int tmp_N_flag=0;
static int tmp_Z_flag=0;
static int tmp_C_flag=0;
static int tmp_V_flag=0;
static int already_npc_set;

int N_flag=0;
int Z_flag=0;
int C_flag=0;
int V_flag=0;

extern int cond;
extern int immd;
extern int rs1;
extern int rs2;
extern int rs3;
extern int rd;
extern int OP;
extern int OP2;
extern int msize;
extern int msex;
extern int n_high;
extern int m_high;
extern int mlist;
extern int madd;
extern int mindex;
extern int mwback;
extern int amode;
extern int muser;
extern int mexret;
extern int word_hi;
extern int mincr;
extern int mrot;
extern int mlsb;
extern int mwidth;

int PC;
int PC1;
int PC2;

extern int inst_reg;

static int IADD32(int src1, int src2, int carry, int* n, int* z, int* c, int* v)
{
  unsigned long long s1,s2,d;
  int s1_sign, s2_sign, d_sign;
  int cy, ov, z_val;
  s1_sign = (src1 & 0x80000000)? 1 : 0;
  s2_sign = (src2 & 0x80000000)? 1 : 0;
  s1 = (unsigned long long)(src1 & 0xffffffffLL);
  s2 = (unsigned long long)(src2 & 0xffffffffLL);
  d  = s1 + s2 + carry;
  d_sign  = (d & 0x080000000LL)? 1 : 0;
  cy      = (d & 0x100000000LL)? 1 : 0;
  z_val   = (d & 0x0ffffffffLL)? 0 : 1;
  if((s1_sign==0)&&(s2_sign==0)&&(d_sign==1))
    ov = 1;
  else if((s1_sign==1)&&(s2_sign==1)&&(d_sign==0))
    ov = 1;
  else
    ov = 0;
  *n      = d_sign;
  *z      = z_val;
  *c      = cy;
  *v      = ov;
  return (int)(d & 0x0ffffffffLL);
}

static int ISUB32(int src1, int src2, int borrow, int* n, int* z, int* c, int* v)
{
  unsigned long long s1,s2,d;
  int s1_sign, s2_sign, d_sign;
  int cy, ov, z_val;
  s1_sign = (src1 & 0x80000000)? 1 : 0;
  s2_sign = (src2 & 0x80000000)? 1 : 0;
  s1 = (unsigned long long)( src1 & 0xffffffffLL);
  s2 = (unsigned long long)(~src2 & 0xffffffffLL);
  d  = s1 + s2 + 1 - borrow;
  d_sign  = (d & 0x080000000LL)? 1 : 0;
  cy      = (d & 0x100000000LL)? 1 : 0;
  z_val   = (d & 0x0ffffffffLL)? 0 : 1;
  if((s1_sign==0)&&(s2_sign==1)&&(d_sign==1))
    ov = 1;
  else if((s1_sign==1)&&(s2_sign==0)&&(d_sign==0))
    ov = 1;
  else
    ov = 0;
  *n      = d_sign;
  *z      = z_val;
  *c      = cy;
  *v      = ov;
  return (int)(d & 0x0ffffffffLL);
}


static int IMUL32(int src1, int src2, int* n, int* z, int* c, int* v)
{
  int d;
  d = src1 * src2;
  *n      = (d & 0x80000000)? 1 : 0;
  *z      = (d == 0)? 1 : 0;
  *c      = 0;
  *v      = 0;
  return d;
}

int ISFT32(int src, int sa, int* n, int* z, int* c, int* v)
{
  long long int d;
  int cy;
  int z_val;
  int d_sign;

  sa = sa &0x1f;
  if(sa == 0){
    cy     = C_flag;
    z_val  = (src==0)? 1 : 0;
    d_sign = (src&0x80000000)? 1: 0;
    d      = src;
  }
  else{
    switch(OP){
    case ROR:
      d = (long long int)src;
      break;
    case SRA:
      if(src&0x80000000)
	d = (long long int)0xffffffffLL;
      else
	d = (long long int)0x00000000LL;
      break;
    case SRL:
    case SLL:
      d = (long long int)0x00000000LL;
      break;
    case RRX:
      d = (long long int)C_flag;
      sa = 1;
      OP = ROR;
    }
    d = (d<<32)|(src&0xffffffffLL);
    if(OP==SLL){
      cy  = (d & (1LL<<(32-sa))) ? 1: 0;
      d = d << sa;
    }
    else{
      cy  = (d & (1LL<<(sa-1))) ? 1: 0;
      d = d >> sa;
    }
    d = d & 0xffffffffLL;
    z_val  = (d==0LL)? 1 : 0;
    d_sign = (d&0x80000000LL)? 1 : 0;
  }
  *n = d_sign;
  *z = z_val;
  *c = cy;
  *v = 0;
  return (int)d;
}

static int v_dst;
static int v_src1;
static int v_src2;
static int v_src3;
static unsigned int v_udst;
static unsigned int v_usrc1;
static unsigned int v_usrc2;
static unsigned int v_usrc3;
static long long int v_ldst;
static long long int v_lsrc1;
static long long int v_lsrc2;
static long long int v_lsrc3;
static unsigned long long int v_uldst;
static unsigned long long int v_ulsrc1;
static unsigned long long int v_ulsrc2;
static unsigned long long int v_ulsrc3;

static int BitCount(int n)
{
  int i;
  int v;
  v = 0;
  for(i=0;i<32;i++){
    if(n&(1<<i))
      v++;
  }
  return v;
}

static void do_stmda(void)
{
  int i;
  int addr;
  int addr0;
  addr0= get_reg(rs1)-4*BitCount(mlist);
  addr = addr0+4;
  for(i=0;i<16;i++){
    if(mlist&(1<<i)){
      put_mem(addr,get_reg(i),WORD);
      addr += 4;
    }
  }
  if(mwback)
    put_reg(rs1,addr0);
}
	
static void do_stmdb(void)
{
  int i;
  int addr;
  int addr0;
  addr0= get_reg(rs1)-4*BitCount(mlist);
  addr = addr0;
  for(i=0;i<16;i++){
    if(mlist&(1<<i)){
      put_mem(addr,get_reg(i),WORD);
      addr += 4;
    }
  }
  if(mwback)
    put_reg(rs1,addr0);
}
	
static void do_stmia(void)
{
  int i;
  int addr;
  int addr0;
  addr0= get_reg(rs1)+4*BitCount(mlist);
  addr = get_reg(rs1);
  for(i=0;i<16;i++){
    if(mlist&(1<<i)){
      put_mem(addr,get_reg(i),WORD);
      addr += 4;
    }
  }
  if(mwback)
    put_reg(rs1,addr0);
}
	
static void do_stmib(void)
{
  int i;
  int addr;
  int addr0;
  addr0= get_reg(rs1)+4*BitCount(mlist);
  addr = get_reg(rs1)+4;
  for(i=0;i<16;i++){
    if(mlist&(1<<i)){
      put_mem(addr,get_reg(i),WORD);
      addr += 4;
    }
  }
  if(mwback)
    put_reg(rs1,addr0);
}
	
static void do_ldmda(void)
{
  int i;
  int addr;
  int addr0;
  addr0= get_reg(rs1)-4*BitCount(mlist);
  addr = addr0+4;
  for(i=0;i<16;i++){
    if(mlist&(1<<i)){
      put_reg(i,get_mem(addr,WORD));
      addr += 4;
      if(i==15)
	already_npc_set |= 1;
    }
  }
  if(mwback)
    put_reg(rs1,addr0);
}
	
static void do_ldmdb(void)
{
  int i;
  int addr;
  int addr0;
  addr0= get_reg(rs1)-4*BitCount(mlist);
  addr = addr0;
  for(i=0;i<16;i++){
    if(mlist&(1<<i)){
      put_reg(i,get_mem(addr,WORD));
      addr += 4;
      if(i==15)
	already_npc_set |= 1;
    }
  }
  if(mwback)
    put_reg(rs1,addr0);
}
	
static void do_ldmia(void)
{
  int i;
  int addr;
  int addr0;
  addr0= get_reg(rs1)+4*BitCount(mlist);
  addr = get_reg(rs1);
  for(i=0;i<16;i++){
    if(mlist&(1<<i)){
      put_reg(i,get_mem(addr,WORD));
      addr += 4;
      if(i==15)
	already_npc_set |= 1;
    }
  }
  if(mwback)
    put_reg(rs1,addr0);
}
	
static void do_ldmib(void)
{
  int i;
  int addr;
  int addr0;
  addr0= get_reg(rs1)+4*BitCount(mlist);
  addr = get_reg(rs1)+4;
  for(i=0;i<16;i++){
    if(mlist&(1<<i)){
      put_reg(i,get_mem(addr,WORD));
      addr += 4;
      if(i==15)
	already_npc_set |= 1;
    }
  }
  if(mwback)
    put_reg(rs1,addr0);
}

static void do_ldstm(void)
{
  if(OP==STM){
    switch(amode){
    case DA:
      do_stmda();
      break;
    case DB:
      do_stmdb();
      break;
    case IA:
      do_stmia();
      break;
    case IB:
      do_stmib();
      break;
    }
  }
  else{
    switch(amode){
    case DA:
      do_ldmda();
      break;
    case DB:
      do_ldmdb();
      break;
    case IA:
      do_ldmia();
      break;
    case IB:
      do_ldmib();
      break;
    }
  }
}

static int extend(int v)
{
  switch(msize){
  case BYTE:
    if(msex){
      return (v&0x80)?  0xffffff00|v : 0xff&v;
    }
    else{
      return v & 0xff;
    }
  case HWORD:
    if(msex){
      return (v&0x8000)? 0xffff0000|v : 0xffff&v;
    }
    else{
      return v & 0xffff;
    }
  default:
    return v;
  }
}

static void do_ldst(void)
{
  int addr;
  addr = (mindex)? v_dst : v_src1;
  if(OP2==ST){
    if(msize==DWORD){
      put_mem(addr, v_src3, WORD);
      put_mem(addr+4, get_reg(rd), WORD);
    }
    else{
      put_mem(addr, v_src3, msize);
    }
  }
  else{
    if(msize==DWORD){
      put_reg(rs3,get_mem(addr,WORD));
      put_reg(rd,get_mem(addr+4,WORD));
    }
    else{
      put_reg(rd,extend(get_mem(addr,msize)));
    }
  }
  if(mwback)
    put_reg(rs1,v_dst);
}


static int get_value(int n)
{
  if((n>=0)&&(n<=14))
    return get_reg(n);
  if(n==15)
    return PC1;
  if(n==IMMD)
    return immd;
  if(n==NEXT_PC)
    return PC2;
  return 0;
}

static void put_value(int n, int v)
{
  if((n>=0)&&(n<=14)){
    put_reg(n,v);
    return;
  }
  if(n==15){
    PC = (v&0xfffffffe);
    already_npc_set = already_npc_set|1;
    return;
  }
  return;
}

static int cond_check()
{
  switch(cond){
  case 0x0:
    return (Z_flag==1);
  case 0x1:
    return (Z_flag==0);
  case 0x2:
    return (C_flag==1);
  case 0x3:
    return (C_flag==0);
  case 0x4:
    return (N_flag==1);
  case 0x5:
    return (N_flag==0);
  case 0x6:
    return (V_flag==1);
  case 0x7:
    return (V_flag==0);
  case 0x8:
    return ((C_flag==1)&&(Z_flag==0));
  case 0x9:
    return ((C_flag==0)||(Z_flag==1));
  case 0xa:
    return (N_flag==V_flag);
  case 0xb:
    return (N_flag!=V_flag);
  case 0xc:
    return ((Z_flag==0)&&(N_flag==V_flag));
  case 0xd:
    return ((Z_flag==1)||(N_flag!=V_flag));
  case 0xe:
  case 0xf:
    return 1;
  }
}

void execute(void)
{
  already_npc_set = 0;
  int i;

  v_src1 = get_value(rs1);
  v_src2 = get_value(rs2);
  v_src3 = get_value(rs3);

  v_usrc1 = (unsigned int)v_src1;
  v_usrc2 = (unsigned int)v_src2;
  v_usrc3 = (unsigned int)v_src3;

  if(cond_check()){
    switch(OP){
    case EADDR:
      if(madd)
	v_dst = v_src1 + v_src2;
      else
	v_dst = v_src1 - v_src2;
      break;
    case AND:
    case TST:
      v_dst = v_src1 & v_src2;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = 0;
      tmp_V_flag = V_flag;
      break;
    case XOR:
    case TEQ:
      v_dst = v_src1 ^ v_src2;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = 0;
      tmp_V_flag = V_flag;
      break;
    case SUB:
    case CMP:
      v_dst = ISUB32(v_src1, v_src2, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
      break;
    case RSB:
      v_dst = ISUB32(v_src2, v_src1, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
      break;
    case ADD:
    case CMN:
      v_dst = IADD32(v_src1, v_src2, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
      break;
    case ADC:
      v_dst = IADD32(v_src1, v_src2, C_flag, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
      break;
    case SBC:
      if(C_flag)
	v_dst = ISUB32(v_src1, v_src2, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
      else
	v_dst = ISUB32(v_src1, v_src2, 1, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
      break;
    case RSC:
      if(C_flag)
	v_dst = ISUB32(v_src2, v_src1, 0, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
      else
	v_dst = ISUB32(v_src2, v_src1, 1, &tmp_N_flag, &tmp_Z_flag, &tmp_C_flag, &tmp_V_flag);
      break;
    case OR:
      v_dst = v_src1 | v_src2;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = 0;
      tmp_V_flag = V_flag;
      break;
    case MOV:
      v_dst = v_src2;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      break;
    case BIC:
      v_dst = v_src1 & ~v_src2;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = 0;
      tmp_V_flag = V_flag;
      break;
    case MVN:
      v_dst = ~v_src2;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      break;
    case SEX:
      if(mrot==1){
	v_udst = (v_usrc2<<24)|(v_usrc2>>8);
      }
      else if(mrot==2){
	v_udst = (v_usrc2<<16)|(v_usrc2>>16);
      }
      else if(mrot==3){
	v_udst = (v_usrc2<<8)|(v_usrc2>>24);
      }
      else{
	v_udst = v_usrc2;
      }
      v_dst = (int)v_udst;
      if(msize==BYTE){
	if(v_dst&0x80)
	  v_dst |= 0xffffff00;
	else
	  v_dst &= 0x000000ff;
      }
      else{
	if(v_dst&0x8000)
	  v_dst |= 0xffff0000;
	else
	  v_dst &= 0x0000ffff;
      }
      break;
    case ZEX:
      if(mrot==1){
	v_udst = (v_usrc2<<24)|(v_usrc2>>8);
      }
      else if(mrot==2){
	v_udst = (v_usrc2<<16)|(v_usrc2>>16);
      }
      else if(mrot==3){
	v_udst = (v_usrc2<<8)|(v_usrc2>>24);
      }
      else{
	v_udst = v_usrc2;
      }
      v_dst = (int)v_udst;
      if(msize==BYTE){
	v_dst &= 0x000000ff;
      }
      else{
	v_dst &= 0x0000ffff;
      }
      break;
    case CLZ:
      for(i=0;i<32;i++){
	if(v_src2 & (1<<(31-i)))
	  break;
      }
      v_dst = i;
      break;
    case MUL:
      v_dst = v_src1 * v_src2;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      break;
    case MLA:
      v_dst = v_src1 * v_src2 + v_src3;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      break;
    case UMAAL:
      v_ulsrc1 = (unsigned long long int)v_src1;
      v_ulsrc2 = (unsigned long long int)v_src2;
      v_ulsrc3 = (unsigned long long int)v_src3;
      v_uldst  = (unsigned long long int)get_reg(rd);
      v_uldst  = v_ulsrc1 * v_ulsrc2 + v_ulsrc3 + v_uldst;
      v_src3   = (int)(v_uldst & 0xffffffffULL);
      v_dst    = (int)((v_uldst>>32) & 0xffffffffULL);
      put_reg(rs3,v_src3);
      break;
    case MLS:
      v_dst = v_src3 - v_src1 * v_src2;
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = (v_dst==0)? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      break;
    case UMULL:
      v_ulsrc1 = (unsigned long long int)(v_src1 & 0xffffffffULL);
      v_ulsrc2 = (unsigned long long int)(v_src2 & 0xffffffffULL);
      v_uldst  = v_ulsrc1 * v_ulsrc2;
      v_src3   = (int)(v_uldst & 0xffffffffULL);
      v_dst    = (int)((v_uldst>>32) & 0xffffffffULL);
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = ((v_dst==0)&&(v_src3==0))? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      put_reg(rs3,v_src3);
      break;
    case UMLAL:
      v_ulsrc1 = (unsigned long long int)(v_src1 & 0xffffffffULL);
      v_ulsrc2 = (unsigned long long int)(v_src2 & 0xffffffffULL);
      v_ulsrc3 = (unsigned long long int)(v_src3 & 0xffffffffULL);
      v_uldst  = (unsigned long long int)(get_reg(rd) & 0xffffffffULL);
      v_ulsrc3 = (v_uldst<<32)|(v_src3&0xffffffffULL);
      v_uldst  = v_ulsrc1 * v_ulsrc2 + v_ulsrc3;
      v_src3   = (int)(v_uldst & 0xffffffffULL);
      v_dst    = (int)((v_uldst>>32) & 0xffffffffULL);
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = ((v_dst==0)&&(v_src3==0))? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      put_reg(rs3,v_src3);
      break;
      break;
    case SMULL:
      v_lsrc1 = (long long int)((v_src1&0x80000000LL)? 0xffffffff00000000LL | v_src1 : 0xffffffffLL & v_src1);
      v_lsrc2 = (long long int)((v_src2&0x80000000LL)? 0xffffffff00000000LL | v_src2 : 0xffffffffLL & v_src2);
      v_ldst  = v_lsrc1 * v_lsrc2;
      v_src3   = (int)(v_ldst & 0xffffffffLL);
      v_dst    = (int)((v_ldst>>32) & 0xffffffffLL);
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = ((v_dst==0)&&(v_src3==0))? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      put_reg(rs3,v_src3);
      break;
    case SMLAL:
      v_lsrc1 = (long long int)((v_src1&0x80000000LL)? 0xffffffff00000000LL | v_src1 : 0xffffffffLL & v_src1);
      v_lsrc2 = (long long int)((v_src2&0x80000000LL)? 0xffffffff00000000LL | v_src2 : 0xffffffffLL & v_src2);
      v_lsrc3 = (long long int)((v_src2&0x80000000LL)? 0xffffffff00000000LL | v_src3 : 0xffffffffLL & v_src3);
      v_ldst  = (long long int)((get_reg(rd)&0x80000000LL)? 0xffffffff00000000LL | get_reg(rd) : 0xffffffffLL & get_reg(rd));
      v_lsrc3 = (v_ldst<<32)|(v_src3&0xffffffffLL);
      v_ldst  = v_lsrc1 * v_ulsrc2 + v_lsrc3;
      v_src3   = (int)(v_uldst & 0xffffffffLL);
      v_dst    = (int)((v_uldst>>32) & 0xffffffffLL);
      tmp_N_flag = (v_dst&0x80000000)? 1: 0;
      tmp_Z_flag = ((v_dst==0)&&(v_src3==0))? 1: 0;
      tmp_C_flag = C_flag;
      tmp_V_flag = V_flag;
      put_reg(rs3,v_src3);
      break;
    case UDIV:
      v_udst = v_usrc1 / v_usrc2;
      v_dst = (int)v_udst;
      break;
    case SDIV:
      v_dst = v_src1 / v_src2;
      break;
    case SMLAxy:
      v_src1 = (n_high)? v_src1>>16 : v_src1;
      v_src2 = (m_high)? v_src2>>16 : v_src2;
      v_src1 = (v_src1 & 0x8000)? 0xffff0000 | v_src1 : 0xffff & v_src1;
      v_src2 = (v_src2 & 0x8000)? 0xffff0000 | v_src2 : 0xffff & v_src2;
      v_dst  = v_src1*v_src2 + v_src3;
      break;
    case SMLALxy:
      v_src1 = (n_high)? v_src1>>16 : v_src1;
      v_src2 = (m_high)? v_src2>>16 : v_src2;
      v_src1 = (v_src1 & 0x8000)? 0xffff0000 | v_src1 : 0xffff & v_src1;
      v_src2 = (v_src2 & 0x8000)? 0xffff0000 | v_src2 : 0xffff & v_src2;
      v_dst  = v_src1*v_src2;
      v_ldst = (v_dst & 0x80000000LL)? 0xffffffff00000000LL | v_dst : 0xffffffffLL & v_dst;
      v_lsrc3 =(long long int)(((long long int)get_reg(rd)<<32)|v_src3);
      v_ldst  = v_ldst + v_lsrc3;
      v_src3   = (int)(v_ldst & 0xffffffffLL);
      v_dst    = (int)((v_ldst>>32) & 0xffffffffLL);
      put_reg(rs3,v_src3);
      break;
    case SMULxy:
      v_src1 = (n_high)? v_src1>>16 : v_src1;
      v_src2 = (m_high)? v_src2>>16 : v_src2;
      v_src1 = (v_src1 & 0x8000)? 0xffff0000 | v_src1 : 0xffff & v_src1;
      v_src2 = (v_src2 & 0x8000)? 0xffff0000 | v_src2 : 0xffff & v_src2;
      v_dst  = v_src1*v_src2;
      break;
    case SMLAWxy:
      v_src2 = (m_high)? v_src2>>16 : v_src2;
      v_src2 = (v_src2 & 0x8000)? 0xffff0000 | v_src2 : 0xffff & v_src2;
      v_src3 = v_src3<<16;
      v_lsrc1 = (v_src1 & 0x80000000LL)? 0xffffffff00000000LL | v_src1 : 0xffffffffLL & v_src1;
      v_lsrc2 = (v_src2 & 0x80000000LL)? 0xffffffff00000000LL | v_src2 : 0xffffffffLL & v_src2;
      v_lsrc3 = (v_src3 & 0x80000000LL)? 0xffffffff00000000LL | v_src3 : 0xffffffffLL & v_src3;
      v_ldst  = v_lsrc1*v_lsrc2 + v_lsrc3;
      v_dst   = (int)((v_ldst>>16)&0xffffffffLL);
      break;
    case SMULWxy:
      v_src2 = (m_high)? v_src2>>16 : v_src2;
      v_src2 = (v_src2 & 0x8000)? 0xffff0000 | v_src2 : 0xffff & v_src2;
      v_lsrc1 = (v_src1 & 0x80000000LL)? 0xffffffff00000000LL | v_src1 : 0xffffffffLL & v_src1;
      v_lsrc2 = (v_src2 & 0x80000000LL)? 0xffffffff00000000LL | v_src2 : 0xffffffffLL & v_src2;
      v_ldst  = v_lsrc1*v_lsrc2;
      v_dst   = (int)((v_ldst>>16)&0xffffffffLL);
      break;
    case UBFX:  
      v_dst  = (v_src1>>mlsb)&((1<<mwidth)-1);
      break;
    case SBFX:
      v_dst  = (v_src1>>mlsb)&((1<<mwidth)-1);
      v_dst  = (v_dst&(1<<(mwidth-1)))? ~((1<<mwidth)-1)|v_dst : v_dst;
      break;
    case BFC:
      v_dst  = ~((0xffffffff&((1<<mwidth)-1))<<mlsb);
      v_dst  = get_reg(rd)&v_dst;
      break;
    case BFI:
      v_dst  = ~((0xffffffff&((1<<mwidth)-1))<<mlsb);
      v_src1 = (v_src1&((1<<mwidth)-1))<<mlsb;
      v_dst  = (get_reg(rd)&v_dst) | (v_src1&~v_dst);
      break;
    case LDM:
    case STM:
      rd = NONE;
      do_ldstm();
      break;
    case NOP:
      break;
    default:
      printf("OP=%d inst_reg=%08x\n",OP,inst_reg);
      exit(1);
    }
    if(rd != NONE){
      put_value(rd, v_dst);
      if(rd==15){
	already_npc_set = already_npc_set|1;
      }
    }
    switch(OP2){
    case FLAG:
      N_flag = tmp_N_flag;
      Z_flag = tmp_Z_flag;
      C_flag = tmp_C_flag;
      V_flag = tmp_V_flag;
      break;
    case JMP:
      put_reg(15,PC1+immd);
      already_npc_set = already_npc_set|1;
      break;
    case JPR:
      put_reg(15,v_src1);
      already_npc_set = already_npc_set|1;
      break;
    case LD:
    case ST:
      do_ldst();
      break;
    case LDREX:
      break;
    case STREX:
      break;
    case SWP:
      break;
    case NOP:
      break;
    default:
      break;
    }
  }
  if(already_npc_set==0){
    put_value(15,PC2);
  }
    
}
