#define MOV  0
#define CMP  1
#define ADDI 2
#define ALU  3
#define JMP  4
#define JPR  5
#define JCC  6
#define LD   7
#define ST   8
#define NOP  9
#define SPC  10
#define EXP  11

#define WORD  0
#define HWORD 1
#define BYTE  2

void reg_dump(void);
int get_reg(int reg);
void put_reg(int reg, int value);

#define MAXPAGENUM 16
int get_mem(int addr, int size);
void put_mem(int addr, int value, int size);
int get_word(int addr);
void put_word(int addr, int data);
void mem_dump(unsigned int start, unsigned int end, int unit);

void fetch(void);
void decode(void);
void execute(void);
void instruction();

void disasm(unsigned int addr1, unsigned int addr2);

